﻿using J2534DotNet;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Cryptography;
using System.Security.Permissions;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace TestApp
{

    class Program
    {

     
        public static BaudRate CAN_baudrate = BaudRate.ISO15765_500000;
        public static UInt32 MASK_CAN_ID_u32 = 0xFFFFFFFF;

        //public static ThreadStart Tester_read { get; private set; }

        static void Main(string[] args)
        {
            //Thread thread_read = new Thread(Tester_read);
            //Thread newThread = new Thread(new ThreadStart(Tester_read));
            J2534Err status = J2534Err.STATUS_NOERROR;
            J2534Err status_read = J2534Err.STATUS_NOERROR;
            bool result = false;
            bool can_tp = true;
            int deviceId = 0;
            int channelId = 0;
            int filterId = 0;
            int nbParams = 0;
            int LOOPBACK = 1;
            int can_tp_data = 0;
            int index1 = 0;
            SConfig configs;
            SCONFIG_LIST configList;
            PassThruMsg txMsg;
            int pNumMsgs = 0;
            int read_buff = 0;
            //newThread.Start();
            //newThread.Join(); 
            // List<SCONFIG_LIST> configList = new List<SCONFIG_LIST>();
            J2534 passThru = new J2534();
            // Find all of the installed J2534 passthru devices
            List<J2534Device> availableJ2534Devices = J2534Detect.ListDevices();
           // List<PassThruMsg> rxMsgs = new List<PassThruMsg>();
            // We will always choose the first J2534 device in the list, if there are multiple devices
            //   installed, you should do something more intelligent.
            // result = passThru.LoadLibrary(availableJ2534Devices[1]);  // pcan device 
            //result = passThru.LoadLibrary(availableJ2534Devices[2]);  // sloki device sBusCan 
            for (int i = 0; i < availableJ2534Devices.Count; i++)
            {
                if (availableJ2534Devices[i].Name == "J2534")
                {
                    result = passThru.LoadLibrary(availableJ2534Devices[i]);  // sloki device sBusCan 
                    break;
                }
            }
            if (result == true)
            {
                //status = passThru.Open(null,ref deviceId);
                status = passThru.Open("=sloki_Testing_Device", ref deviceId); // Recevier_Device  =Sloki_Testing_Device// ~~Sloki_Testing_Device~~
                if (status == J2534Err.STATUS_NOERROR)
                {
                    if (can_tp)
                    {
                       // status = passThru.Connect(deviceId, ProtocolID.CAN, ConnectFlag.NONE, BaudRate.ISO15765_500000, ref channelId);
                        status = passThru.Connect(deviceId, ProtocolID.CAN, ConnectFlag.NONE, CAN_baudrate, ref channelId);
                        if (status == J2534Err.STATUS_NOERROR)
                        {
                            status = passThru.ClearMsgFilters(channelId);
                            if (status == J2534Err.STATUS_NOERROR)
                            {
                                 
                                PassThruMsg maskMsg = new PassThruMsg(ProtocolID.CAN, TxFlag.ISO15765_FRAME_PAD, new byte[] { 0xFF, 0xFF, 0xFF, 0xFF });
                                PassThruMsg patternMsg = new PassThruMsg(ProtocolID.CAN, TxFlag.ISO15765_FRAME_PAD, new byte[] { 0x00, 0x00, 0x07, 0xF1 });
                                PassThruMsg flowControlMsg = new PassThruMsg(ProtocolID.CAN, TxFlag.ISO15765_FRAME_PAD, new byte[] { 0x00, 0x00, 0x07, 0xFD });
                                status = passThru.StartMsgFilter(channelId, FilterType.PASS_FILTER, ref maskMsg, ref patternMsg, ref flowControlMsg, ref filterId);
                               // if (status == J2534Err.STATUS_NOERROR)
                                {
                                    status = passThru.ClearRxBuffer(channelId);
                                    if (status == J2534Err.STATUS_NOERROR)
                                    {
                                       // SetConfigurationParameter Parameter = SetConfigurationParameter.Iso15765SeparateTimeMinimum;
                                       // status = passThru.SetConfig(channelId, Parameter, 0);
                                        if (status == J2534Err.STATUS_NOERROR)
                                        {
                                            //Parameter = SetConfigurationParameter.Iso15765BlockSize;
                                            //status = passThru.SetConfig(channelId, Parameter, 0);
                                            if (status == J2534Err.STATUS_NOERROR)
                                            {
                                                int count_1 = 0;
                                               // while (status_read != (J2534Err)10)
                                                {
                                                    //count_1++;
                                                    //txMsg = new PassThruMsg(ProtocolID.ISO15765,TxFlag.NONE,new byte[] { 0x00, 0x00, 0x07, 0xDf, 0x02, 0x06, 00 });
                                                    List<PassThruMsg> rxMsgs = new List<PassThruMsg>();
                                                    //for (index1 = 0; index1 < 1; index1++)
                                                    //{
                                                    byte[] data = new byte[12];//4099//504
                                                    byte m = 0;
                                                    data[0] = 0;
                                                    data[1] = 0;
                                                    data[2] = 7;
                                                    data[3] = 0xFD;
                                                    data[4] = 0x1;
                                                    data[5] = 0x2;
                                                    data[6] = 0x3;
                                                    data[7] = 0x4;
                                                    data[8] = 0x5;
                                                    data[9] = 0x6;
                                                    data[10] = 0x7;
                                                    data[11] = 0x8;
                                                    //for (UInt16 l = 4; l < 500; l++)
                                                    //{
                                                    //    data[l] = m++;

                                                    //}
                                                    // txMsg = new PassThruMsg(ProtocolID.ISO15765,TxFlag.ISO15765_FRAME_PAD,
                                                    txMsg = new PassThruMsg(ProtocolID.CAN, TxFlag.ISO15765_FRAME_PAD,
                                                      //iteration-2bytes //length-2bytes
                                                      //new byte[] { 0x00, 0x00, 0x07, 0xF0, 0x01, 0xFF, 0x00, 0x0F, 0xFF });//0x515
                                                      data);
                                                    pNumMsgs = 1;
                                                    //    status = passThru.WriteMsgs(channelId, ref txMsg, ref pNumMsgs, 0);
                                                    //    if (status == J2534Err.STATUS_NOERROR)
                                                    //    {

                                                    //        Console.WriteLine(" can write ");
                                                    //    }
                                                    //    else
                                                    //    {
                                                    //        Console.WriteLine(" can error ");
                                                    //    }

                                                    //}
                                                    //object value = Tester_read(channelId, rxMsgs, pNumMsgs);
                                                    //Tester_read();
                                                    count_1 = 0;
                                                    while (status_read != (J2534Err)10)
                                                    {
                                                        count_1++;
                                                        status_read = passThru.ReadMsgs(channelId, ref rxMsgs, ref pNumMsgs, 0, (int)ProtocolID.CAN);
                                                        if (status_read == J2534Err.STATUS_NOERROR)
                                                        {
                                                            Console.WriteLine(" can read ");
                                                            //rxMsgs->Count;
                                                            //rxMsgs[0].Data[0];
                                                            status = passThru.WriteMsgs(channelId, ref txMsg, ref pNumMsgs, 0);
                                                            Thread.Sleep(1000);
                                                            passThru.Disconnect(channelId);
                                                            passThru.FreeLibrary();
                                                            break;

                                                        }
                                                        else
                                                        {
                                                            Console.WriteLine(" no can read ");
                                                        }
                                                        Thread.Sleep(10);
                                                        if (count_1 == 50)
                                                        {
                                                            passThru.Disconnect(channelId);
                                                            passThru.FreeLibrary();
                                                            break;
                                                            //     break;
                                                        }
                                                    }
                                                }
                                            }

                                        }
                                    }
                                }
                            }
                        }
                    }
                    else
                    {
                        status = passThru.Connect(deviceId, ProtocolID.ISO15765, ConnectFlag.NONE, BaudRate.ISO15765_500000, ref channelId);
                        if (status == J2534Err.STATUS_NOERROR)
                        {
                            status = passThru.ClearMsgFilters(channelId);
                            if (status == J2534Err.STATUS_NOERROR)
                            {
                                //PassThruMsg maskMsg = new PassThruMsg(ProtocolID.ISO15765, TxFlag.ISO15765_FRAME_PAD, new byte[] { 0x00, 0x00, 0x07, 0xFF });
                                PassThruMsg maskMsg = new PassThruMsg(ProtocolID.ISO15765, TxFlag.ISO15765_FRAME_PAD, new byte[] { 0xFF, 0xFF, 0xFF, 0xFF });
                                PassThruMsg patternMsg = new PassThruMsg(ProtocolID.ISO15765, TxFlag.ISO15765_FRAME_PAD, new byte[] { 0x00, 0x00, 0x07, 0xF1 });
                                PassThruMsg flowControlMsg = new PassThruMsg(ProtocolID.ISO15765, TxFlag.ISO15765_FRAME_PAD, new byte[] { 0x00, 0x00, 0x07, 0xF0 });
                                //PassThruMsg flowControlMsg = new PassThruMsg(ProtocolID.ISO15765, TxFlag.ISO15765_FRAME_PAD, new byte[] { 0x00, 0x00, 0x07, 0xC8 });
                                status = passThru.StartMsgFilter(channelId, FilterType.FLOW_CONTROL_FILTER, ref maskMsg, ref patternMsg, ref flowControlMsg, ref filterId);
                                if (status == J2534Err.STATUS_NOERROR)
                                {
                                    status = passThru.ClearRxBuffer(channelId);
                                    if (status == J2534Err.STATUS_NOERROR)
                                    {
                                        SetConfigurationParameter Parameter = SetConfigurationParameter.Iso15765SeparateTimeMinimum;
                                       // status = passThru.SetConfig(channelId, Parameter, 0);
                                        if (status == J2534Err.STATUS_NOERROR)
                                        {
                                            Parameter = SetConfigurationParameter.Iso15765BlockSize;
                                            status = passThru.SetConfig(channelId, Parameter, 0);
                                            if (status == J2534Err.STATUS_NOERROR)
                                            {
                                                int count_1 = 0;
                                                while (status_read != (J2534Err)10)
                                                {
                                                    count_1++;
                                                    //txMsg = new PassThruMsg(ProtocolID.ISO15765,TxFlag.NONE,new byte[] { 0x00, 0x00, 0x07, 0xDf, 0x02, 0x06, 00 });
                                                    List<PassThruMsg> rxMsgs = new List<PassThruMsg>();
                                                    for (index1 = 0; index1 < 1; index1++)
                                                    {
                                                        byte[] data = new byte[4096];//4099//504
                                                        byte m = 0;
                                                        data[0] = 0;
                                                        data[1] = 0;
                                                        data[2] = 0x7;
                                                        data[3] = 0xF0; //0xf0;
                                                        data[4] = 0x1;
                                                        data[5] = 0x2;
                                                        data[6] = 0x3;
                                                        data[7] = 0x4;
                                                        data[8] = 0x5;
                                                        data[9] = 0x6;
                                                        data[10] = 0x7;
                                                        data[11] = 0x8;
                                                        //for (UInt16 l = 4; l < 500; l++)
                                                        //{
                                                        //    data[l] = m++;

                                                        //}
                                                        // txMsg = new PassThruMsg(ProtocolID.ISO15765,TxFlag.ISO15765_FRAME_PAD,
                                                        txMsg = new PassThruMsg(ProtocolID.ISO15765, TxFlag.ISO15765_FRAME_PAD,
                                                          //iteration-2bytes //length-2bytes
                                                          //new byte[] { 0x00, 0x00, 0x07, 0xF0, 0x01, 0xFF, 0x00, 0x0F, 0xFF });//0x515
                                                          data);
                                                        pNumMsgs = 1;
                                                        status = passThru.WriteMsgs(channelId, ref txMsg, ref pNumMsgs, 0);
                                                        if (status == J2534Err.STATUS_NOERROR)
                                                        {

                                                            Console.WriteLine(" can write ");
                                                        }
                                                        else
                                                        {
                                                            Console.WriteLine(" can error ");
                                                        }

                                                    }
                                                    Thread.Sleep(100);
                                                    status_read = passThru.ReadMsgs(channelId, ref rxMsgs, ref pNumMsgs, 0, (int)ProtocolID.ISO15765);
                                                    if (status_read == J2534Err.STATUS_NOERROR)
                                                    {
                                                        Console.WriteLine(" can read ");
                                                        //rxMsgs->Count;
                                                        //rxMsgs[0].Data[0];
                                                       
                                                    }
                                                    else
                                                    {
                                                        Console.WriteLine(" no can read ");
                                                    }
                                                    if (count_1 == 10)
                                                    {
                                                        break;
                                                    }
                                                }
                                            }

                                        }
                                    }
                                }
                            }
                        }

                        //#endif
                    }
                }

               
            }
            //     passThru.Disconnect(channelId); // todo sanjay

            // When we are done with the device, we can free the library.

            //     passThru.FreeLibrary();todo sanjay
        }
        // static void Tester_read(int channelId, List<PassThruMsg> rxMsgs, int pNumMsgs)
        //static void Tester_read()
        //{
        //    int channelId = 0;
        //    List<PassThruMsg> rxMsgs_1 = new List<PassThruMsg>();
        //    int pNumMsgs = 1;
        //    J2534 passThru = new J2534();
        //    J2534Err status_read_1 = J2534Err.STATUS_NOERROR;
        //    while (status_read_1 != (J2534Err)10)
        //    {
        //        status_read_1 = passThru.ReadMsgs(channelId, ref rxMsgs_1, ref pNumMsgs, 0);
        //        if (status_read_1 == J2534Err.STATUS_NOERROR)
        //        {
        //            Console.WriteLine(" can read ");
        //            rxMsgs->Count;
        //            rxMsgs[0].Data[0];


        //        }
        //        else
        //        {
        //            Console.WriteLine(" no can read ");
        //        }

        //    }
        //}
    }

   
    

}


//status = passThru.ClearMsgFilters(channelId);
//if(status == J2534Err.STATUS_NOERROR)
//{

//}

//PassThruMsg maskMsg = new PassThruMsg(ProtocolID.ISO15765, TxFlag.ISO15765_FRAME_PAD, new byte[] { 0xFF, 0xFF, 0xFF, 0xFF });
//PassThruMsg patternMsg = new PassThruMsg(ProtocolID.ISO15765, TxFlag.ISO15765_FRAME_PAD,new byte[] { 0x00, 0x00, 0x07, 0xF1 });
//PassThruMsg flowControlMsg = new PassThruMsg(ProtocolID.ISO15765, TxFlag.ISO15765_FRAME_PAD,new byte[] { 0x00, 0x00, 0x07, 0xF0 });

//status = passThru.StartMsgFilter(channelId, FilterType.FLOW_CONTROL_FILTER, ref maskMsg, ref patternMsg, ref flowControlMsg, ref filterId);
//if (status == J2534Err.STATUS_NOERROR)
//{
//    nbParams = 0;
//    configs.Parameter = LOOPBACK;
//    configs.Value = 1;
//    configList.NumOfParams = nbParams;
//    configList.ConfigPtr = configs;
//    //status =  passThru.GetConfig(channelId,ref configList);
//    SetConfigurationParameter Parameter = SetConfigurationParameter.Iso15765SeparateTimeMinimum;
//    status = passThru.SetConfig(channelId,  Parameter, 0);
//    if(status == J2534Err.STATUS_NOERROR)
//    {
//        txMsg = new PassThruMsg(ProtocolID.ISO15765, TxFlag.ISO15765_FRAME_PAD, new byte[] { 0x00, 0x00, 0x07, 0xDf, 0x02, 0x06, 00 });
//        pNumMsgs = 1;
//        status = passThru.WriteMsgs(channelId, ref txMsg, ref pNumMsgs, 0);
//        if (status == J2534Err.STATUS_NOERROR)
//        {
//            List<PassThruMsg> rxMsgs = new List<PassThruMsg>();
//            //rxMsgs = new PassThruMsg(ProtocolID.ISO15765,)
//            status = passThru.ReadMsgs(channelId, ref rxMsgs, ref pNumMsgs, 0);
//            if (status == J2534Err.STATUS_NOERROR)
//            {
//                for(int i=0; i<rxMsgs.Count; i++)
//                {
//                    can_tp_data = rxMsgs[i].Data[i];

//                    Console.WriteLine("\t data read : " + can_tp_data );
//                }
//                Console.WriteLine("\n");
//            }
//            else
//            {
//                Console.WriteLine("\t no data read : " );
//            }
//        }
//    }

//}

// Attempt to open a communication link with the pass thru device


// Open a new channel configured for ISO15765 (CAN)

// passThru.Connect(deviceId, ProtocolID.ISO15765, ConnectFlag.NONE, BaudRate.ISO15765_500000, ref channelId);
//  passThru.Connect(deviceId, ProtocolID.ISO15765, ConnectFlag.NONE, BaudRate.ISO15765_500000, ref channelId);
//passThru.Disconnect(channelId);
//passThru.Close(deviceId);
//passThru.Open(ref deviceId);

//     passThru.Close(deviceId);
//     passThru.Open(ref deviceId);
//passThru.Connect(deviceId, ProtocolID.ISO15765, ConnectFlag.NONE, BaudRate.ISO15765_500000, ref channelId);
//passThru.Disconnect(channelId);
//passThru.Connect(deviceId, ProtocolID.ISO15765, ConnectFlag.NONE, BaudRate.ISO15765_250000, ref channelId);
//passThru.Disconnect(channelId);
//passThru.Connect(deviceId, ProtocolID.ISO15765, ConnectFlag.NONE, BaudRate.ISO15765_250000, ref channelId);
//passThru.Disconnect(channelId);
//passThru.Connect(deviceId, ProtocolID.ISO15765, ConnectFlag.NONE, BaudRate.ISO15765_250000, ref channelId);
//passThru.Disconnect(channelId);
//passThru.Connect(deviceId, ProtocolID.ISO15765, ConnectFlag.NONE, BaudRate.ISO15765_500000, ref channelId);
// passThru.Disconnect(channelId);
// Set up a message filter to watch for response messages
// passThru.J2534_DEBUG_Enable(channelId);
// int filterId = 0;
//PassThruMsg maskMsg = new PassThruMsg(
//    ProtocolID.CAN,
//    TxFlag.ISO15765_FRAME_PAD,
//     new byte[] { 0x00, 0x00, 0x07, 0xFF });
//    new byte[] { 0x00, 0x00, 0x07, 0xee });
//PassThruMsg patternMsg = new PassThruMsg(
//    ProtocolID.CAN,
//    TxFlag.ISO15765_FRAME_PAD,
//     new byte[] { 0x00, 0x00, 0x07, 0xF1 });
//      new byte[] { 0x00, 0x00, 0x07, 0xE0 });
//PassThruMsg flowControlMsg = new PassThruMsg(
//    ProtocolID.CAN,
//    TxFlag.ISO15765_FRAME_PAD,
//     new byte[] { 0x00, 0x00, 0x07, 0xF0 });
//     new byte[] { 0x00, 0x00, 0x07, 0xF1 });
//passThru.StartMsgFilter(channelId, FilterType.FLOW_CONTROL_FILTER, ref maskMsg, ref patternMsg, ref flowControlMsg, ref filterId);


//Thread.Sleep(1000);
///**/
// maskMsg = new PassThruMsg(
//    ProtocolID.CAN,
//    TxFlag.ISO15765_FRAME_PAD,
//     new byte[] { 0x00, 0x00, 0x07, 0xFF });
////    new byte[] { 0x00, 0x00, 0x07, 0xEE });
// patternMsg = new PassThruMsg(
//    ProtocolID.CAN,
//    TxFlag.ISO15765_FRAME_PAD,
//     new byte[] { 0x00, 0x00, 0x07, 0xF4 });
////      new byte[] { 0x00, 0x00, 0x07, 0xE0 });
// flowControlMsg = new PassThruMsg(
//    ProtocolID.CAN,
//    TxFlag.ISO15765_FRAME_PAD,
//     new byte[] { 0x00, 0x00, 0x07, 0xF2 });
////     new byte[] { 0x00, 0x00, 0x07, 0xF1 });
//passThru.StartMsgFilter(channelId, FilterType.FLOW_CONTROL_FILTER, ref maskMsg, ref patternMsg, ref flowControlMsg, ref filterId);
/**/
/************************/
// flowControlMsg = new PassThruMsg(ProtocolID.CAN, TxFlag.ISO15765_FRAME_PAD, new byte[] { 0x00, 0x00, 0x07, 0x77 });
// passThru.StartMsgFilter(channelId, FilterType.FLOW_CONTROL_FILTER, ref maskMsg, ref patternMsg, ref flowControlMsg, ref filterId);



/************************/


//  // Clear out the response buffer so we know we're getting the freshest possible data
//  passThru.ClearRxBuffer(channelId);
//SetConfigurationParameter Parameter = SetConfigurationParameter.Iso15765SeparateTimeMinimum;

//  passThru.SetConfig(channelId, Parameter, 0);
//  Parameter = SetConfigurationParameter.Iso15765BlockSize;
//  passThru.SetConfig(channelId, Parameter, 0);


//PassThruMsg txMsg13 = new PassThruMsg(
//   ProtocolID.CAN,
//   TxFlag.NONE,
//   new byte[] { 0x00, 0x00, 0x07, 0xDf, 0x02, 0x06, 00 });
//int numMsgs = 1;
//passThru.WriteMsgs(channelId, ref txMsg13, ref numMsgs, 0);


//  List<PassThruMsg> rxMsgs = new List<PassThruMsg>();


// // J2534Err status = J2534Err.STATUS_NOERROR;
//  txMsg13 = new PassThruMsg(
//     ProtocolID.CAN,
//     TxFlag.ISO15765_FRAME_PAD,
//                                          //iteration-2bytes //length-2bytes
//     new byte[] { 0x00, 0x00, 0x07, 0xF0, 0x07,0xFF, 0x0F, 0xFF});





/*uncomment from 423-437*/
//// passThru.WriteMsgs(channelId, ref txMsg13, ref numMsgs, 0);
// txMsg13 = new PassThruMsg(
//    ProtocolID.ISO15765,
//    TxFlag.ISO15765_FRAME_PAD,
//    //iteration //length-2bytes
//    new byte[] { 0x00, 0x00, 0x07, 0xF4, 0x1F, 0x2F, 0xFF });
//// passThru.StartPeriodicMsg(channelId, ref txMsg13, ref numMsgs, 300);
/* TxMsg.id = Can_ID;
 TxMsg.dlc = 8;
 TxMsg.isExtended = false;
 flag = true;
 TxMsg.data[0] = data;
 TxMsg.data[1] = 0x00;
 TxMsg.data[2] = 0x00;
 TxMsg.data[3] = 0x00;
 TxMsg.data[4] = 0x00;
 TxMsg.data[5] = 0x00;
 TxMsg.data[6] = 0x00;
 TxMsg.data[7] = 0x00;


 SendMsg(TxMsg);
*/
// //passThru.StartPeriodicMsg(channelId, ref txMsg13, ref numMsgs, 300);
// while (status != (J2534Err)8)
// {
//     //Thread.Sleep();
//     status = passThru.ReadMsgs(channelId, ref rxMsgs, ref numMsgs, 0);
// }

//   passThru.WriteMsgs(channelId, ref txMsg3, ref numMsgs, 10);
//while (status != (J2534Err)9)
//{
//    status = passThru.ReadMsgs(channelId, ref rxMsgs, ref numMsgs, 0);

//}
//status = 0;
// byte[] data = new byte[8];
// byte m = 0;
// data[0] = 0;
// data[1] = 0;
// data[2] = 7;
// data[3] = 0xf2;
// data[4] = 0x1;
// data[5] = 0x0F;
// data[6] = 0xFF;
// PassThruMsg txMsgbulk = new PassThruMsg(
// ProtocolID.CAN,
// TxFlag.ISO15765_FRAME_PAD,
// data);
// numMsgs = 1;
//     passThru.WriteMsgs(channelId, ref txMsgbulk, ref numMsgs, 0);
// data[4] = 0x0;
// data[5] = 0x0;
// data[6] = 0x0;
// for (UInt16 l = 4; l < 8; l++)
// {
//     data[l] = m++;


// }
// status = J2534Err.ERR_BUFFER_EMPTY;
//int counter = 0;

// for (int p = 0; p < 150000; p++)
// {
//     // Thread.Sleep(5);
//    passThru.WriteMsgs(channelId, ref txMsgbulk, ref numMsgs, 0);

//     for (UInt16 l = 4; l < 8; l++)
//     {
//         data[l] = m++;


//     }
//     numMsgs = 1;


//     //Thread.Sleep(1);
//     /*    do {
//         numMsgs = 1;
//         passThru.datasent = false;
//         Thread.Sleep(150);
//         status = passThru.ReadMsgs(channelId, ref rxMsgs, ref numMsgs, 300);


//           if(passThru.datasent == true)
//         {
//             counter += 4099;
//             Console.Write(counter + "\n");
//         }
//         } while (passThru.datasent==false);
//         passThru.datasent = false;*/


//     status = 0;
// }
// // passThru.ClearRxBuffer(channelId);
// while(true)
// {
//     Thread.Sleep(350);
//     status = passThru.ReadMsgs(channelId, ref rxMsgs, ref numMsgs, 300);
// }



//
//
// Now do something with the data!
//
//

// Disconnect this channel
//passThru.Disconnect(channelId);

//// When we are done with the device, we can free the library.
//passThru.FreeLibrary();





//        }
//    }
//}
